; ================================================================================================
; Konverter von tpm2-Protokoll auf WS2801/WS2811/TM1804
; Baudrate setzen
; ================================================================================================

.equ UBRR_VAL_250 = 3 							; UBBR fr 250 k bei 16 MHz

.equ UBRR_VAL_500 = 1 							; UBBR fr 500 k bei 16 MHz

.equ UBRR_VAL_1000 = 0						 	; UBBR fr 1 M bei 16 MHz

; ================================================================================================
; USART Baudrate setzen
; ------------------------------------------------------------------------------------------------

_set_baudrate:

		push	temp0
		push	temp1

		lds		temp0, RX_BAUDRATE				; Baudrate holen (0 = 250k, 1 = 500k, 2 = 1,25M)

		cpi		temp0, 1						; 500 k eingestellt?
		brne	_sbr_no_500						; nein, weiter
		ldi		temp0, UBRR_VAL_500				; ja, 500 einstellen
		rjmp	_sbr_set_ubbr

_sbr_no_500:

		cpi		temp0, 2						; 1 M eingestellt?
		brne	_sbr_no_1000					; nein, weiter
		ldi		temp0, UBRR_VAL_1000			; ja, 1 M einstellen
		rjmp	_sbr_set_ubbr

_sbr_no_1000:

		ldi		temp0, UBRR_VAL_250				; bleibt noch 250k

_sbr_set_ubbr:

    	out 	UBRRL, temp0					; Usart auf Baudrate setzen
    	clr 	temp0
    	out 	UBRRH, temp0

    	ldi 	temp0, (3<<UCSZ0) |	(1<<URSEL)	; 8 Datenbits, 1 Stoppbit
    	out 	UCSRC, temp0			
		sbi 	UCSRB, RXEN						; Receiver enable
		sbi		UCSRB, TXEN						; Transmitter enable
		sbi 	UCSRB, RXCIE					; RX Complete Int. enable
		sbi 	UCSRB, TXCIE					; TX Complete Int. enable

		clr		rx_state						; Start-Status: auf Blockstart warten
		clr		rx_timeout						; Timeout zurcksetzen
		
		sts		RX_FE_COUNT, rx_timeout			; gezhlte FE zurck setzen
			
		pop		temp1
		pop		temp0

		ret

; ================================================================================================

